#include <memory>
#include <iostream>

struct DebugStruct
{
	DebugStruct()
	{
		std::cout << "Constructor\n";
	}
	
	~DebugStruct()
	{
		std::cout << "Destructor\n";
	}
	
	void Print()
	{
		std::cout << "Salut lume\n";
	}
};

int main()
{
	std::unique_ptr<DebugStruct> p(new DebugStruct);
	// Unique ptr nu poate fi copiat sau atribuit
	// dar poate fi mutat
	//std::unique_ptr<DebugStruct> q = std::move(p);
	
	if (p)
	{
		std::cout << "Nu e null\n";
	}
	else
	{
		std::cout << "E null\n";
	}
	
	return 0;
}
