#include <memory>
#include <iostream>

struct DebugStruct
{
	DebugStruct()
	{
		std::cout << "Constructor\n";
	}
	
	~DebugStruct()
	{
		std::cout << "Destructor\n";
	}
	
	void Print()
	{
		std::cout << "Salut lume\n";
	}
};

int main()
{
	std::unique_ptr<DebugStruct> p(new DebugStruct);
	p.reset(new DebugStruct); // Inlocuieste obiectul 
							  // gestionat de p cu altul
	p.reset();
	
	std::cout << "Am terminat\n";
	return 0;
}


