#include <memory>
#include <iostream>

struct DebugStruct
{
	DebugStruct()
	{
		std::cout << "Constructor\n";
	}
	
	~DebugStruct()
	{
		std::cout << "Destructor\n";
	}
	
	void Print()
	{
		std::cout << "Salut lume\n";
	}
};

int main()
{
	// std::shared_ptr<DebugStruct> a(new DebugStruct);
	auto p = std::make_shared<DebugStruct>();
	std::cout << p.use_count() << '\n';
	
	std::shared_ptr<DebugStruct> q = p;
	std::cout << p.use_count() << '\n';
	
	q.reset();
	std::cout << p.use_count() << '\n';
	
	return 0;
}
