#include <memory>
#include <iostream>

struct DebugStruct
{
	DebugStruct()
	{
		std::cout << "Constructor\n";
	}
	
	~DebugStruct()
	{
		std::cout << "Destructor\n";
	}
	
	void Print()
	{
		std::cout << "Salut lume\n";
	}
};

int main()
{
	std::unique_ptr<DebugStruct> p(new DebugStruct);
	
	// Smart pointerii supraincarca operatorul de
	// acces indirect si operatorul de dereferentiere
	p->Print();
	(*p).Print();	
	
	return 0;
}

