#include <memory>
#include <iostream>

struct DebugStruct
{
	DebugStruct()
	{
		std::cout << "Constructor\n";
	}
	
	~DebugStruct()
	{
		std::cout << "Destructor\n";
	}
	
	void Print()
	{
		std::cout << "Salut lume\n";
	}
};

int main()
{
	std::unique_ptr<DebugStruct> p(new DebugStruct);
	
	std::cout << p.get() << '\n';
	
	// Release renunta la gestionarea pointer-ului
	// si il returneaza
	DebugStruct* q = p.release();
	
	// Dupa apelarea functiei release,
	// programatorul e responsabil de 
	// eliberarea resurselor
	delete q;
	
	return 0;
}



